Imports Microsoft.VisualBasic.ControlChars
Imports System.Runtime.InteropServices

Public Class ClipboardWatcher : Inherits NativeWindow : Implements IDisposable

    <DllImport("user32", EntryPoint:="SetClipboardViewer")> _
    Private Shared Function SetClipboardViewer(ByVal hWnd As IntPtr) As IntPtr
    End Function

    Public Event Changed As EventHandler

    Private _hview As IntPtr

    'nur eine globale Instanz zulassen
    Public Shared Singleton As New ClipboardWatcher

    Private Sub New()
        MyBase.CreateHandle(New CreateParams)
        _hview = SetClipboardViewer(MyBase.Handle)
    End Sub

    Protected Overrides Sub WndProc(ByRef m As Message)
        Const WM_DRAWCLIPBOARD As Integer = &H308
        Select Case m.Msg
            Case WM_DRAWCLIPBOARD
                RaiseEvent Changed(Me, EventArgs.Empty)
        End Select
        MyBase.WndProc(m)
    End Sub

#Region " IDisposable Support "
    ' Fr diese Klasse ist korrekte Ressourcenbereinigung besonders wichtig, da 
    ' mit systembergreifenden Ressourcen gearbeitet wird

    ' So ermitteln Sie berflssige Aufrufe
    Private disposedValue As Boolean = False

    Protected Overridable Sub Dispose(ByVal disposing As Boolean)
        If Not Me.disposedValue Then
            If disposing Then
                ' TODO: Verwaltete Ressourcen freigeben, wenn sie explizit 
                ' aufgerufen werden
            End If
            MyBase.DestroyHandle()
            Dim H As IntPtr = SetClipboardViewer(_hview)
        End If
        Me.disposedValue = True
    End Sub

    ' Dieser Code wird von Visual Basic hinzugefgt, um das Dispose-Muster 
    ' richtig zu implementieren.
    Public Sub Dispose() Implements IDisposable.Dispose
        ' Sie sollten diesen Code nicht ndern, sondern stattdessen ihren
        ' Bereinigungscode oben in 
        ' Dispose(ByVal disposing As Boolean) einfgen.
        Dispose(True)
        GC.SuppressFinalize(Me)
    End Sub

    Protected Overrides Sub Finalize()
        MyBase.Finalize()
        Dispose(False)
    End Sub

#End Region

End Class
